<template>
  <q-form
    ref="form"
    @submit="onOKClick"
  >
    <q-card-section>
      <q-select
        v-model="train"
        filled
        label="Vlak"
        :options="trainOptions"
        option-label="name"
        option-value="id"
        :rules="[
          val => val || 'Prosím zadejte vlak',
        ]"
        :disable="detail"
        @filter="loadTrainOptions"
      />
    </q-card-section>

    <q-card-section>
      <div
        class="row justify-between items-center"
        style="max-width: 30%;"
      >
        <div class="col-6">
          Rychlost
          <q-icon
            color="secondary"
            name="speed"
            style="font-size: 2em;"
          />
        </div>
        <div class="col-6">
          <q-slider
            v-model="speed"
            name="speed"
            :min="0"
            :max="31"
            :step="1"
            snap
            label
            label-always
            color="primary"
            :disable="detail"
          />
        </div>
      </div>

      <div>
        Spuštěn: {{ running ? 'Ano' : 'Ne' }}
      </div>
    </q-card-section>

    <q-card-section>
      <map-select
        ref="mapSelect"
        :detail="detail"
        :journeyprom="journeyPromise"
      />
    </q-card-section>

    <buttons
      v-if="showBtns"
      :add-label="addLabel"
      @onCancelClick="$emit('onCancelClick')"
    />
  </q-form>
</template>
<script lang="ts">
import { ref } from '@vue/reactivity'
import { useQuasar } from 'quasar'
import { defineComponent } from 'vue'
import { JourneyAdd, JourneyDirection, StationModel, TrainModel } from 'web_trains_types'

import MapSelect from '@/components/Map/MapSelect.vue'
import Buttons from '@/components/Timetable/Buttons.vue'
import { journeyService, trainService } from '@/service'

export default defineComponent({
  name: 'JourneyAdd',
  components: {
    Buttons,
    MapSelect
  },
  props: {
    id: {
      type: Number,
      required: true
    },
    showBtns: {
      type: Boolean,
      reguired: false,
      default: true
    },
    detail: {
      type: Boolean,
      reguired: false,
      default: false
    }
  },
  emits: [
    'onOKClick',
    'onCancelClick'
  ],
  setup (props, { emit }): any {
    const $q = useQuasar()

    const train = ref<TrainModel>()
    const trainOptions = ref<TrainModel[]>()
    const addLabel = ref('Uložit')
    const form = ref()
    const running = ref()
    const mapSelect = ref()

    const speed = ref(0)

    const loadTrainOptions = (val: string, update: any) => {
      if (trainOptions.value !== undefined) {
        update()
        return
      }

      trainService.getAll()
        .then((data) => {
          update(() => {
            trainOptions.value = data
          })
        })
    }

    const addJourney = (journey: JourneyAdd) => {
      return journeyService
        .add(journey)
        .then((data) => {
          $q.notify({
            type: 'positive',
            message: 'Jízda přidána'
          })
          emit('onOKClick', data)
        })
    }

    const updateJourney = (id: number, journey: JourneyAdd) => {
      return journeyService
        .patch(id, journey)
        .then(() => {
          $q.notify({
            type: 'positive',
            message: 'Jízda byla upravena'
          })
          emit('onOKClick')
        })
    }

    const onOKClick = () => {
      $q.loading.show()

      const selected = mapSelect.value.getSelected()

      const from = selected.shift()
      const to = selected.pop()

      const journey = {
        stationFromId: from ? from.id : null,
        stationToId: to ? to.id : null,
        trainId: train.value?.id ?? 0,
        section: selected.map((sel: StationModel) => sel.id),
        speed: speed.value,
        direction: JourneyDirection.ahead
      }

      let addUpdatePromise = null

      if (props.id === 0) {
        addUpdatePromise = addJourney(journey)
      } else {
        addUpdatePromise = updateJourney(props.id, journey)
      }

      addUpdatePromise
        .finally(() => {
          $q.loading.hide()
        })
    }

    let journeyPromise = null

    if (props.id !== 0) {
      $q.loading.show()
      addLabel.value = 'Upravit'

      journeyPromise = journeyService.get(props.id)

      journeyPromise.then((journey) => {
        train.value = journey.train
        speed.value = journey.speed
        running.value = journey.running
      })
        .finally(() => { $q.loading.hide() })
    }

    return {
      onOKClick,
      loadTrainOptions,
      trainOptions,
      train,
      addLabel,
      form,
      speed,
      submit: () => form.value.submit(),
      running,
      mapSelect,
      journeyPromise
    }
  }
})

</script>
